.psx
.open "SLUS_005.95",0x8000F800

;#######Level Cap###############################
.org 0x80053874		;intercepts normal "level up check"
j _LevelUpCrashFix	;jump to fix
_return:	
;###############################################


;;#######Random Fix##############################
;These replace calls to original Random routine with location of fixed routine. Game's original random routine at 0x1b69c
.org 0x80023930 
	jal _Random
.org 0x80023950 
	jal _Random
.org 0x80025518	;enemy turn over
	jal _Random
.org 0x80025608
	jal _Random
.org 0x80025688 ;enemy turn over
	jal _Random	
.org 0x80025788
	jal _Random	
.org 0x8002609C	;enemy move
	jal _Random
.org 0x80026B24 ;enemy turn over
	jal _Random	
.org 0x80027430
	jal _Random	
.org 0x80029BF4
	jal _Random	
.org 0x8002AA78
	jal _Random	
.org 0x8002AB20
	jal _Random	
.org 0x8002ABAC
	jal _Random	
.org 0x8002BD38 ;summoner level up
	jal _Random	
.org 0x8002BD9C
	jal _Random	
.org 0x8002BE00
	jal _Random	
.org 0x8002BE60
	jal _Random	
.org 0x8002FD94
	jal _Random	
.org 0x8002FEC0
	jal _Random	
.org 0x8003003C
	jal _Random	
.org 0x8003006C
	jal _Random	
.org 0x800302F0
	jal _Random	
.org 0x800306C0
	jal _Random		
.org 0x800306EC	
	jal _Random
.org 0x80032274		
	jal _Random		
.org 0x800323C8	;sleep spell affect test 	
	jal _Random
.org 0x800326D8
	jal _Random
.org 0x8003273C
	jal _Random
.org 0x800327A0
	jal _Random
.org 0x80032800
	jal _Random
.org 0x80032BD0
	jal _Random	
.org 0x80032C34
	jal _Random
.org 0x80032C98
	jal _Random
.org 0x80032CF8
	jal _Random
.org 0x80045ed4 ;For summon new creature (stats?)
	jal _Random
.org 0x8003347c ;For earth quake spell affect test
	jal _Random
.org 0x80029B58 ;For tower item awards
	jal _Random
.org 0x8002a8e8 ;attack hit test	
	jal _Random	
.org 0x8005ed04 ;creature fusion results
	jal _Random
;###############################################	


;#############Fixes#############################
.org 0x80017818		;writes to unused "debug area"
.word 0x00000001		;Sets starting seed
 
_Random:			;New Random routine.
lui r2,0x8001		;Load seed location
lw r2,0x7818(r2) 
lui r3, 0x41c6
ori r3,r3,0x4e6d
mult r2,r3
mflo r2
addiu r2,r2,0x3039
lui r3,0x8001
sw r2,0x7818(r3)		;Stores new seed
srl r2,r2,0x10		
addiu r3,r0,100
divu r2,r3			
jr r31
mfhi r2			;returns random in r2
;###############################################	

;###############################################
_LevelUpCrashFix:
lbu r6,0x15(r17)		;moved original code- player level to r6
nop
sltiu r2,r6,99		;test if player level is at 99
bgtz r2,_end		;return if level below 99
nop
sb r0,0x2c(r17)		;zeros out player curent exp. if lvl =99
_end:
j _return +4		;return
nop
;###############################################


.close
